       ID DIVISION.
       PROGRAM-ID. NOXA.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.
       01  CONNSTR           PIC X(20) VARYING.
       01  EMP-REC-VARS.
           05  EMP-NAME      PIC X(10) VARYING.
           05  EMP-NUMBER    PIC S9(4) COMP VALUE ZERO.
           05  SALARY        PIC S9(5)V99 COMP-3 VALUE ZERO.
           05  COMMISSION    PIC S9(5)V99 COMP-3 VALUE ZERO.
           05  COMM-IND      PIC S9(4) COMP VALUE ZERO.
           EXEC SQL END DECLARE SECTION END-EXEC.
           EXEC SQL INCLUDE SQLCA END-EXEC.
       01  R-SALARY      PIC Z(4)9.99.
       01  R-COMMISSION  PIC Z(4)9.99.
       LINKAGE SECTION.
       01  RETURNED-VARIABLES.
           05  R-EMP-NAME     PIC X(10).
           05  R-SALARYX      PIC X(8).
           05  R-COMMISSIONX  PIC X(8).
           05  R-EMP-NUMBER   PIC 9(4).
       PROCEDURE DIVISION USING RETURNED-VARIABLES.
       BEGIN-PGM.
           EXEC SQL WHENEVER SQLERROR
              DO PERFORM SQL-ERROR END-EXEC.

           PERFORM LOGON.
           PERFORM OBTAIN-EMP-VAL.
           PERFORM SET-RETVAL.
           PERFORM SIGN-OFF.
           GOBACK.

       OBTAIN-EMP-VAL.
           MOVE R-EMP-NUMBER TO EMP-NUMBER.
           MOVE SPACES TO EMP-NAME-ARR.
           EXEC SQL SELECT ENAME, SAL, COMM
               INTO :EMP-NAME, :SALARY, :COMMISSION:COMM-IND
               FROM EMP
               WHERE EMPNO = :EMP-NUMBER
           END-EXEC.
           EXIT.

       LOGON.
           MOVE "scott/tiger@orcl" TO CONNSTR-ARR.
           MOVE 16 TO CONNSTR-LEN.
           EXEC SQL
               CONNECT :CONNSTR
           END-EXEC.
           EXIT.

       SET-RETVAL.
           MOVE EMP-NAME-ARR TO R-EMP-NAME.
           MOVE SALARY TO R-SALARY.
           MOVE R-SALARY TO R-SALARYX.
           IF COMM-IND = -1
               MOVE 0 TO R-COMMISSION
           ELSE
               MOVE COMMISSION TO R-COMMISSION
           END-IF.
           MOVE R-COMMISSION TO R-COMMISSIONX.
           EXIT.

       SIGN-OFF.
           EXEC SQL COMMIT WORK RELEASE END-EXEC.
           EXIT.

       SQL-ERROR.
           EXEC SQL WHENEVER SQLERROR CONTINUE END-EXEC.
           DISPLAY "ORACLE ERROR DETECTED:" UPON CONSOLE.
           DISPLAY SQLERRMC UPON CONSOLE.
           EXEC SQL ROLLBACK WORK RELEASE END-EXEC.
           GOBACK.
